local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are 

local f = CreateFrame("FRAME");
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

local isCombustion = false;

-- Initialize addon
function frame:OnEvent(event, arg1)
	-- This is the first time this addon is loaded; initialize the count to 0.
	if event == "ADDON_LOADED" and arg1 == "ChumliDied" then
		if ChumliDiedCount == nil then
			ChumliDiedCount = 0;
		end
		if SaelarisDiedCount == nil then
			SaelarisDiedCount = 0;
		end
		if FaldrikDiedCount == nil then
			FaldrikDiedCount = 0; 
		end
		if RubricDiedCount == nil then
			RubricDiedCount = 0; 
		end
		if UrbricDiedCount == nil then
			UrbricDiedCount = 0; 
		end
		if ChappyDiedCount == nil then
			ChappyDiedCount = 0; 
		end
		if KimoraDiedCount == nil then
			KimoraDiedCount = 0; 
		end
		if SolarialDiedCount == nil then
			SolarialDiedCount = 0; 
		end
		if KuruzuDiedCount == nil then
			KuruzuDiedCount = 0; 
		end
		if DubDiedCount == nil then
			DubDiedCount = 0; 
		end
		if PingwingDiedCount == nil then
			PingwingDiedCount = 0; 
		end
		if BexDiedCount == nil then
			BexDiedCount = 0; 
		end
		if CaliraDiedCount == nil then
			CaliraDiedCount = 0;
		end
		print("Tracking alot of deaths");
	end
end
frame:SetScript("OnEvent", frame.OnEvent);

-- Start counting
f:SetScript("OnEvent", function(self, event)
	-- pass a variable number of arguments
	self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)

function f:OnEvent(self, ...)
	local timestamp, subevent, _, _, _, _, _, _, destName, _, _, spellId, spellName = ...;
	if subevent == "UNIT_DIED" and UnitInRaid(destName) then
		-- Chumli (legacy)
		if destName == "Chumli" then
			ChumliDiedCount = ChumliDiedCount + 1; -- Chumli died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\saelaris.wav");
			print("Chumli met his untimely end! His death has been counted " .. ChumliDiedCount .. " times!");
		end
		-- Saelaris
		if destName == "Saelaris" then
			SaelarisDiedCount = SaelarisDiedCount + 1; -- Saelaris died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\saelaris.wav");
			print("Saelaris is in danger! Too late... His death has been counted " .. SaelarisDiedCount .. " times!");
		end
		-- Faldrik
		if destName == "Faldrik" then
			FaldrikDiedCount = FaldrikDiedCount + 1; -- Faldrik died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\faldrik.wav");
			print("Faldrik's been stabbed " .. FaldrikDiedCount .. " times! For the watch!");
		end
		-- Rubric
		if destName == "Rubric" then
			RubricDiedCount = RubricDiedCount + 1; -- Rubric died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\rubric.ogg");
			print("Rubric has died giving his best! We have mourned his death " .. RubricDiedCount .. " times!");
		end
		-- Urbric
		if destName == "Urbric" then 
			isFeign = UnitIsFeignDeath("unit");
			if isFeign == false then
				UrbricDiedCount = UrbricDiedCount + 1; -- Urbric died
				PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\urbric.ogg");
				print("It should've been alcoholism, but other reasons took Urbric " .. UrbricDiedCount .. " times!");
			end
		end
		-- Chappy
		if destName == "Chappy" then
			ChappyDiedCount = ChappyDiedCount + 1; -- Chappy died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\chappy.ogg");
			print("Chappy's soul was abducted into the nether! His soul has been stolen " .. ChappyDiedCount .. " times!");
		end
		-- Kimora
		if destName == "Kimora" then
			KimoraDiedCount = KimoraDiedCount + 1; -- Kimora died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\kimora.wav");
			print("Poor Kimora is wasted! But she seemed happy about it " .. KimoraDiedCount .. " times!");
		end
		-- Solarial
		if destName == "Solarial" then
			SolarialDiedCount = SolarialDiedCount + 1; -- Solarial died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\solarial.ogg");
			print("Solarial is now chicken nuggets! He provided substenance to the raid " .. SolarialDiedCount .. " times!");
		end
		-- Kuruzu 
		if destName == "Kuruzu" then
			KuruzuDiedCount = KuruzuDiedCount + 1; -- Kuruzu died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\kuruzu.wav");
			print("Kuruzu failed at plumbing! He fell into a gap " .. KuruzuDiedCount .. " times!");
		end
		-- Dub 
		if destName == "Dub" then
			DubDiedCount = DubDiedCount + 1; -- Dub died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\dub.wav");
			print("At least he didn't explode the raid? Dub died " .. DubDiedCount .. " times!");
		end
		-- Pingwing
		if destName == "Pingwing" then 
			isFeign = UnitIsFeignDeath("unit");
			if isFeign == false then
				PingwingDiedCount = PingwingDiedCount + 1; -- Pingwing died
				PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\pingwing.wav");
				print("For his next trick, Pingwing disappeared (permanently) " .. PingwingDiedCount .. " times!");
			end
		end
		-- Bex 
		if destName == "Bex" then
			BexDiedCount = BexDiedCount + 1; -- Bex died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\bex.wav");
			print("Bex forgot to heal herself, that wasn't smart " .. BexDiedCount .. " times!");
		end
		-- Calira 
		if destName == "Calira" then
			CaliraDiedCount = CaliraDiedCount + 1; -- Calira died
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\calira.wav");
			print("Calira has been disappointed " .. CaliraDiedCount .. " times.");
		end
	end

	if (subevent == "SPELL_AURA_APPLIED" and UnitInRaid(destName)) then
		-- Rubric
		if (destName == "Rubric" and spellName == "Combustion" and isCombustion == false) then
			PlaySoundFile("Interface\\AddOns\\ChumliDied\\sounds\\rubric-combustion.ogg");
			if(UnitName("player") == "Rubric") then
				SendChatMessage("'s eyes glow with fire, having triggered combustion!", "EMOTE" );
				isCombustion = true;
			end
		elseif (destName == "Rubric" and spellName == "Combustion" and isCombustion == true) then
			isCombustion = false;
		end
	end
end

-- Slash commands
SLASH_CHUMLIDIED1 = "/chdd";
SlashCmdList["CHUMLIDIED"] = function(msg)
	if msg == "shout" then
		-- Link to raidchat
		SendChatMessage("I have witnessed Chumli's untimely demise " .. ChumliDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Saelaris's untimely demise " .. SaelarisDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Faldrik's timely demise " .. FaldrikDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Rubric's timely demise " .. RubricDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Urbric's timely demise " .. UrbricDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Chappy's timely demise " .. ChappyDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Kimora's timely demise " .. KimoraDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Solarial's timely demise " .. SolarialDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Kuruzu's timely demise " .. KuruzuDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Pingwing's timely demise " .. PingwingDiedCount .. " times", "RAID" );
		SendChatMessage("I have witnessed Bex's timely demise " .. BexDiedCount .. " times", "RAID" );
		SendChatMessage("Calira has been disappointed " .. CaliraDiedcount .. " times", "RAID" );
	else
		-- Print messages
		print("You have witnessed Chumli's untimely demise " .. ChumliDiedCount .. " times.");
		print("You have witnessed Saelaris's untimely demise " .. SaelarisDiedCount .. " times.");
		print("You have witnessed Faldrik's untimely demise " .. FaldrikDiedCount .. " times.");
		print("You have witnessed Rubric's untimely demise " .. RubricDiedCount .. " times.");
		print("You have witnessed Urbric's untimely demise " .. UrbricDiedCount .. " times.");
		print("You have witnessed Chappy's untimely demise " .. ChappyDiedCount .. " times.");
		print("You have witnessed Kimora's untimely demise " .. FaldrikDiedCount .. " times.");
		print("You have witnessed Solarial's untimely demise " .. SolarialDiedCount .. " times.");
		print("You have witnessed Kuruzu's untimely demise " .. KuruzuDiedCount .. " times.");
		print("You have witnessed Pingwing's untimely demise " .. PingwingDiedCount .. " times.");
		print("You have witnessed Bex's untimely demise " .. BexDiedCount .. " times.");
		print("Calira has been disappointed " .. CaliraDiedcount .. " times");
	end
end